﻿
Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '
        Me.Text = AppTitleAndVersion()
        '
        Load_INI()
        SetFastDrawingButtonColors()
        '
        ' --------------------------------------------------------------------------------
        ReadOptionsFile()
        ReadDataFile(True)
        SetXaxisTimeUnit()
        gbox_Graph.Text = IO.Path.GetFileName(DataFilePathAndName)
        '
        ' --------------------------------------------------------------------------------

        GraphPaper1.PB_Graph = pbox_Graph
        Form2.SetZoom()
        '
        If Me.WindowState <> FormWindowState.Minimized Then
            ShowForm2()
        End If
        '
        Me.Refresh()
        Form2.Refresh()
        Me.Opacity = 1
        Form2.Opacity = 1
        '
        Timer1.Interval = 30
        Timer1.Start()
        EventsAreEnabled = True
        ' ------------------------------------------------- this makes SendKeys faster
        SchedulerMaxPrecision()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Save_INI()
        FormOptionsHelp.Close()
        SchedulerDefaultPrecision()
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        If WindowState = FormWindowState.Minimized Then Return
    End Sub

    Private OldWindowState As FormWindowState
    Private Sub Form1_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Return
        ' --------------------------------------------------------------- restore normal placement
        If Me.WindowState = FormWindowState.Normal Then
            If OldWindowState = FormWindowState.Minimized Then
                EventsAreEnabled = False
                ShowForm2()
                EventsAreEnabled = True
            Else
            End If
        End If
        OldWindowState = Me.WindowState
        LimitFormPosition(Me)
    End Sub

    Private Sub gbox_Graph_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles gbox_Graph.Resize
        If Not EventsAreEnabled Then Return
        TimeGraphRefreshFlag = True
    End Sub

    Private Sub gbox_Graph_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles gbox_Graph.MouseLeave
        lbl_TrackInfo.Visible = False
        GraphPaper1.TrackInfo = ""
    End Sub
    Private Sub TrackBar1_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TrackBar1.MouseEnter, _
                                                                                                  TrackBar2.MouseEnter, _
                                                                                                  TrackBar3.MouseEnter
        lbl_TrackInfo.Visible = False
        GraphPaper1.TrackInfo = ""
    End Sub

    Private Sub ShowForm2()
        If Form2_VisibleAtStart Then
            Form2.Location = New Point(Form2_PositionX, Form2_PositionY)
            Form2.Show(Me)
        End If
    End Sub


    ' =====================================================================================
    '  BUTTONS
    ' =====================================================================================
    Private Sub btn_SaveImage_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_SaveImage.ClickButtonArea
        SaveControlImage("Image_", gbox_Graph)
    End Sub
    Private Sub pbox_Graph_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbox_Graph.Click
        SaveControlImage("Image_", gbox_Graph)
    End Sub

    Private Sub BTN_SelectFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BTN_SelectFile.Click
        SelectDataFile()
        GraphPaper1.UpdateGraph()
    End Sub
    Private Sub BTN_EditFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BTN_EditFile.Click
        On Error Resume Next
        Process.Start(DataFilePathAndName)
    End Sub

    Private Sub BTN_SelectOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BTN_SelectOptions.Click
        SelectOptionsFile()
        Form2.ShowAxisOptions()
        GraphPaper1.UpdateGraph()
    End Sub
    Private Sub BTN_EditOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BTN_EditOptions.Click
        If Form2.Visible Then
            Form2.Hide()
        Else
            Form2.Location = New Point(Form2_PositionX, Form2_PositionY)
            LimitFormPosition_CompletelyVisible(Form2)
            Form2.Show(Me)
            Form2.ShowAxisOptions()
        End If
        Form2_IsVisible = Form2.Visible
    End Sub

    Friend FastDrawing As Boolean
    Private Sub BTN_FastDrawing_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BTN_FastDrawing.Click
        FastDrawing = Not FastDrawing
        SetFastDrawingButtonColors()
        TimeGraphRefreshFlag = True
    End Sub
    Private Sub SetFastDrawingButtonColors()
        If FastDrawing Then
            BTN_FastDrawing.BackColor = Color.FromArgb(255, 240, 100)
        Else
            BTN_FastDrawing.BackColor = Color.WhiteSmoke
        End If
    End Sub

    Private Sub BTN_ChangeGraphType_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BTN_ChangeGraphType.Click
        GraphPaper1.GraphType = (GraphPaper1.GraphType + 1) Mod 3
        TimeGraphRefreshFlag = True
    End Sub

    ' ====================================================================================================
    '  TRACK BARS
    ' ====================================================================================================
    Private Sub TrackBar1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar1.ValueChanged
        If Not EventsAreEnabled Then Return
        TrackBar1.Refresh()
        ReadDataFile(True)
        SetXaxisTimeUnit()
        GraphPaper1.UpdateGraph()
        pbox_Graph.Refresh()
    End Sub
    Private Sub TrackBar2_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar2.ValueChanged
        If Not EventsAreEnabled Then Return
        TrackBar2.Refresh()
        SetSmoothing()
        GraphPaper1.UpdateGraph()
        pbox_Graph.Refresh()
    End Sub
    Private Sub TrackBar3_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar3.ValueChanged
        If Not EventsAreEnabled Then Return
        TrackBar3.Refresh()
        SetSmoothing()
        GraphPaper1.UpdateGraph()
        pbox_Graph.Refresh()
    End Sub



    ' ====================================================================================================
    '  TIMER
    ' ====================================================================================================
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ' ----------------------------------------------------------------- update if files changed
        TestDataFile()
        ' ----------------------------------------------------------------- 
        If TimeGraphRefreshFlag Then
            TimeGraphRefreshFlag = False
            GraphPaper1.UpdateGraph()
        End If
        ' ----------------------------------------------------------------- 
        ShowTrackInfo()
    End Sub

    ' ====================================================================================================
    '  SHOW TRACK INFO
    ' ====================================================================================================
    Private Sub pbox_Graph_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbox_Graph.MouseMove
        GraphPaper1.PrepareTrackInfo(e.X, e.Y)
        TrackInfo_UpdateGraphTimer.Interval = 200
        TrackInfo_UpdateGraphTimer.Start()
    End Sub

    Private WithEvents TrackInfo_UpdateGraphTimer As New Timer
    Private Sub TrackInfo_UpdateGraphTimer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles TrackInfo_UpdateGraphTimer.Tick
        TrackInfo_UpdateGraphTimer.Stop()
        GraphPaper1.UpdateGraph()
    End Sub

    Private Sub pbox_Graph_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles pbox_Graph.MouseLeave
        If GraphPaper1.SelectedTrack >= 0 Then
            GraphPaper1.SelectedTrack = -1
            GraphPaper1.UpdateGraph()
        End If
    End Sub

    Private Sub ShowTrackInfo()
        If GraphPaper1.TrackInfo <> "" Then
            Dim p As Point = Point.Add(pbox_Graph.PointToClient(Cursor.Position), New Size(20, -10))
            If p.Y < pbox_Graph.Height Then
                lbl_TrackInfo.Text = GraphPaper1.TrackInfo
                lbl_TrackInfo.Location = p
                lbl_TrackInfo.Visible = True
            Else
                lbl_TrackInfo.Visible = False
            End If
        Else
            lbl_TrackInfo.Visible = False
        End If
    End Sub

End Class

