﻿
Public Class Form2

    Friend Options_FirstVisibleLine As Int32

    Private Sub Form2_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        Text = AppTitleAndVersion() + " - Options editor"
        ' ShowAxisOptions()
        LimitFormPosition(Me)
        ' ---------------------------
        Timer100ms.Interval = 100
        Timer100ms.Start()
    End Sub

    Private Sub Form2_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.VisibleChanged
        If Me.Visible Then
            TextBox1.SetFirstVisibleLine(Options_FirstVisibleLine)
        Else
            Options_FirstVisibleLine = TextBox1.GetFirstVisibleLine
        End If
    End Sub

    Private Sub Form2_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) Handles Me.FormClosing

        If e.CloseReason <> CloseReason.WindowsShutDown And _
          e.CloseReason <> CloseReason.FormOwnerClosing Then
            Form2_IsVisible = False
            Me.Hide()
            e.Cancel = True
        End If
    End Sub

    Private Sub Form2_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        Form2_PositionX = Me.Location.X
        Form2_PositionY = Me.Location.Y
        LimitFormPosition(Me)
        Save_INI()
    End Sub

    Private Sub Form2_ResizeEnd(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ResizeEnd
        Refresh() ' This restores the vertical scroll bar in some cases
    End Sub

    Private Sub TextBox1_MouseWheel(ByVal sender As Object, ByVal e As MouseEventArgs) Handles TextBox1.MouseWheel
        If My.Computer.Keyboard.CtrlKeyDown Then
            ZoomFactor_Form2 = TextBox1.ZoomFactor
            SetZoom()
        End If
    End Sub

    Friend Sub SetZoom()
        If ZoomFactor_Form2 = 0 Then ZoomFactor_Form2 = 1
        TextBox1.SaveScroll()
        TextBox1.ZoomFactor = 0.1
        TextBox1.ZoomFactor = ZoomFactor_Form2
        TextBox1.RestoreScroll()
    End Sub

    ' ===================================================================================
    '  Events accepting the first click
    ' ===================================================================================
    '  If the form receives a WM_PARENTNOTIFY (528) message and is not focused 
    '  then the form is activated before to exec the message.
    ' ===================================================================================
    <System.Diagnostics.DebuggerStepThrough()> _
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
        End If
        MyBase.WndProc(m)
    End Sub

    Friend Sub ShowAxisOptions()
        If Not EventsAreEnabled Then Return
        ReadOptionsFile()
        ReadDataFile()
        SetXaxisTimeUnit()
    End Sub

    Private Sub TextBox1_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged
        If Not EventsAreEnabled Then Return
        WriteOptionsFile()
        ReadDataFile()
        SetXaxisTimeUnit()
        TimeGraphRefreshFlag = True
    End Sub

    ' =========================================================================================================
    '  TOOLS
    ' =========================================================================================================
    Private Sub chk_Load_CheckedChanged(ByVal sender As System.Object, ByVal e As EventArgs) Handles chk_Load.Click
        SelectOptionsFile()
        GraphPaper1.UpdateGraph()
        TextBox1.Focus()
    End Sub
    Private Sub chk_Save_CheckedChanged(ByVal sender As System.Object, ByVal e As EventArgs) Handles chk_Save.Click
        SaveOptionsFile()
        TextBox1.Focus()
    End Sub
    Private Sub chk_Comment_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_Comment.Click
        TextBox1.CommentSelectedLines(True)
        TextBox1.Focus()
    End Sub
    Private Sub chk_Uncomment_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_Uncomment.Click
        TextBox1.CommentSelectedLines(False)
        TextBox1.Focus()
    End Sub
    Private Sub chk_Undo_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles chk_Undo.MouseDown
        AutorepeatStart("UNDO")
    End Sub
    Private Sub chk_Redo_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles chk_Redo.MouseDown
        AutorepeatStart("REDO")
    End Sub
    Private Sub chk_Help_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_Help.Click
        FormOptionsHelp.StartPosition = FormStartPosition.CenterScreen
        FormOptionsHelp.Hide()
        FormOptionsHelp.Show()
        FormOptionsHelp.TopMost = True
    End Sub

    Private Sub Timer100ms_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer100ms.Tick
        ' ------------------------------------------------------- Enable/Disable tools
        chk_Undo.Enabled = TextBox1.Editor_CanUndo
        chk_Redo.Enabled = TextBox1.Editor_CanRedo
    End Sub

End Class