﻿Module Module_DataFile

    Friend DataFilePathAndName As String = Application.StartupPath
    Friend DataLines(-1) As String

    Friend LeftColumnsCount As Int32 = 1
    Friend ColumnSize As Int32 = 44
    Friend NumDigits As Int32 = 4

    Friend Sub SelectDataFile()
        Dim ofd As OpenFileDialog = New OpenFileDialog()
        ofd.InitialDirectory = IO.Path.GetDirectoryName(DataFilePathAndName)
        If Not IO.Directory.Exists(ofd.InitialDirectory) Then
            ofd.InitialDirectory = Application.StartupPath
        End If
        ofd.Multiselect = True
        ofd.Filter = "Data file (*.*)|*.*"
        ofd.DefaultExt = ".txt"
        IO.Directory.CreateDirectory(ofd.InitialDirectory)
        SendKeys.Send("+{TAB}+{TAB}" + EscapeSpecialCharacters(IO.Path.GetFileName(DataFilePathAndName)) + "{TAB}{TAB}")
        If ofd.ShowDialog() = Windows.Forms.DialogResult.OK Then
            DataFilePathAndName = ofd.FileName
            Form1.gbox_Graph.Text = IO.Path.GetFileName(DataFilePathAndName)
            ReadDataFile(True)
            SetXaxisTimeUnit()
        End If
    End Sub


    Friend DataRows(-1, -1) As Double
    Friend DataRowsSmoothed(-1, -1) As Double

    Friend NumDataLines As Int32
    Friend NumDataColumns As Int32

    Friend FirstValidLine As Int32

    Friend File_NumLines As Int32 = 0
    Friend Visible_NumLines As Int32 = 0
    Friend Visible_FirstLine As Int32 = 0

    Friend StartDate As DateTime

    Friend ScaleFromRight As Boolean = True

    Friend Sub ReadDataFile(Optional ByVal ReadLengthBefore As Boolean = False)
        Try
            If ReadLengthBefore Then
                DataLines = IO.File.ReadAllLines(DataFilePathAndName)
                File_NumLines = DataLines.Length
            End If
            ReadDataFile_Protected()
        Catch
        End Try
    End Sub

    Private Sub ReadDataFile_Protected()
        ' --------------------------------------------------------------------- 17mS (release) 20mS (debug) for longTest2 431K - 5400 lines
        'Dim sw As Stopwatch = New Stopwatch : sw.Start()
        ' ---------------------------------------------------------------------
        If My.Computer.FileSystem.FileExists(DataFilePathAndName) And Axes.Length > 0 Then
            '
            If File_NumLines > 0 Then
                If XaxisIsTime Then
                    Visible_NumLines = CInt(File_NumLines * Form1.TrackBar1.Value / 1000)
                    Visible_FirstLine = 0
                    If Visible_NumLines < 10 Then Visible_NumLines = 10
                Else
                    Visible_FirstLine = 0
                    Visible_NumLines = File_NumLines - Visible_FirstLine
                End If
            End If

            ' TODO ----- XaxisIsTime and Form1.TrackBar1.Value < 1000
            '
            ' ----------------------------------------------------------------- read file
            If XaxisIsTime And Form1.TrackBar1.Value < 1000 Then
                DataLines = ReadLastFileLines(DataFilePathAndName, Visible_NumLines)
            Else
                DataLines = IO.File.ReadAllLines(DataFilePathAndName)
            End If

            'Form1.Text = sw.ElapsedMilliseconds.ToString
            '
            ' ----------------------------------------------------------------- 
            NumDataLines = DataLines.Length
            If NumDataLines > 2 Then
                '
                ' ------------------------------------------------------------- Prepare FirstValidLine
                FirstValidLine = -1
                Dim FirstChar As String
                For i As Int32 = 0 To 50
                    If i < DataLines.Length Then
                        If DataLines(i) <> "" Then
                            FirstChar = Left(DataLines(i), 1)
                            If InStr("-+", FirstChar) > 0 Then
                                FirstChar = Mid(DataLines(i), 1, 1)
                            End If
                            If InStr("1234567890", FirstChar) > 0 Then
                                FirstValidLine = i
                                Exit For
                            End If
                        End If
                    End If
                Next
                ' -------------------------------------------------------------
                If FirstValidLine < 0 Then Return
                ' -------------------------------------------------------------
                If Visible_FirstLine > FirstValidLine Then
                    FirstValidLine = Visible_FirstLine
                End If
                '
                ' ------------------------------------------------------------- Prepare NumDataColumns reading first 5 lines
                NumDataColumns = 1
                Dim sa() As String
                For i As Int32 = FirstValidLine To FirstValidLine + 4
                    If i < DataLines.Length Then
                        sa = DataLines(i).Split(";"c)
                        NumDataColumns = Math.Max(NumDataColumns, sa.Length)
                    End If
                Next
                ' ------------------------------------------------------------- ReDim the DataRows array
                ReDim DataRows(NumDataLines - 1, NumDataColumns - 1)
                '
                ' TODO ----- XaxisIsTime DATA FILE
                ' ------------------------------------------------------------- read lines (do not use the first line containing text)
                If XaxisIsTime Then
                    Dim d As DateTime
                    StartDate = Date.MinValue
                    Dim value As Double
                    ' --------------------------------------------------------- read lines containing time in the column zero
                    For i As Int32 = FirstValidLine To DataLines.Length - 1
                        sa = DataLines(i).Split(";"c)
                        If sa.Length = NumDataColumns Then
                            ' ------------------------------------------------- read the DataRow values
                            For j As Int32 = 1 To sa.Length - 1
                                DataRows(i, j) = Val(sa(j))
                            Next
                            ' ------------------------------------------------- decode time
                            d = Date.Parse(sa(Axes(0).Column))
                            If StartDate = Date.MinValue Then
                                StartDate = d
                                Axes(0).ValueMin = 0
                            End If
                            Axes(0).ValueMax = d.Subtract(StartDate).TotalSeconds
                            DataRows(i, 0) = Axes(0).ValueMax
                            ' ------------------------------------------------- update min and max
                            For j As Int32 = 1 To Axes.Length - 1
                                With Axes(j)
                                    If .Column < NumDataColumns Then
                                        value = Val(sa(.Column))
                                        .ValueMin = Math.Min(.ValueMin, value)
                                        .ValueMax = Math.Max(.ValueMax, value)
                                    End If
                                End With
                            Next
                        End If
                    Next
                Else
                    ' --------------------------------------------------------- read lines containing numbers in all the columns
                    For i As Int32 = FirstValidLine To DataLines.Length - 1
                        sa = DataLines(i).Split(";"c)
                        If sa.Length = NumDataColumns Then
                            ' ------------------------------------------------- read the DataRow values
                            For j As Int32 = 0 To sa.Length - 1
                                DataRows(i, j) = Val(sa(j))
                            Next
                        End If
                    Next
                End If
            End If

        End If
        ' ---------------------------------------------------------------------
        ' Form1.Text = sw.ElapsedMilliseconds.ToString
    End Sub

    ' ==============================================================
    '  READ LAST FILE LINES
    ' ==============================================================
    'Friend InitialDate As DateTime

    Public Function ReadLastFileLines(ByVal file As String, ByVal NumLines As Int32) As String()
        Dim Lines() As String = IO.File.ReadAllLines(file)

        ' --------------------------------------------------------------------- EXTRACT INITIAL DATE (unused)
        ' TODO - EXTRACT INITIAL DATE
        'For i As Int32 = 0 To 100
        '    If Date.TryParse(Strings.Left(Lines(i), 23), InitialDate) Then
        '        Exit For
        '    End If
        'Next
        ' --------------------------------------------------------------------- REMOVE INITIAL PART
        Dim n As Int32 = Math.Min(Lines.Length, NumLines)
        Dim Result(n - 1) As String
        Array.Copy(Lines, Lines.Length - n, Result, 0, n)
        Return Result
    End Function


    ' ==============================================================
    '  TEST DataFile AND RELOAD IF CHANGED
    ' ============================================================== 
    Friend Sub TestDataFile()
        ' -------------------------------------------------- reduce the test frequency if called by a fast timer
        Static counter As Int32
        counter += 1
        If counter < 3 Then Return ' 3 = 300 mS with a 10 Hz Timer / 20 = 300 mS with a 60 hz timer
        counter = 0
        ' --------------------------------------------------  
        If DataFilePathAndName Is Nothing Then Return
        Static DataFileInfo As IO.FileInfo = Nothing
        Dim newinfo As IO.FileInfo = My.Computer.FileSystem.GetFileInfo(DataFilePathAndName)
        If DataFileInfo Is Nothing Then
            DataFileInfo = newinfo
        End If
        If newinfo.LastWriteTime <> DataFileInfo.LastWriteTime Then
            DataFileInfo = newinfo
            ReadDataFile()
            SetXaxisTimeUnit()
            GraphPaper1.UpdateGraph()
        End If
    End Sub

End Module
